clear
clc
close all
% Get list of czi files
filenames = dir('*.czi*');
% List .czi files in console
fprintf('Choose Image File\n')
for i = 1:length(filenames)
    fprintf('%d: %s\n',i,filenames(i).name);
end
% Get user to choose filename
while true
    in = input('Enter Number of Choice\n');
    if in<=length(filenames)
        break
    else
        fprintf('Invalid Input!\n Try Again\n');
    end
end
% Open .czi file and take a maximum z projection for ease in analysis
[img metadata] = openCZI_tiles(filenames(in).name);
% Extract layers
greenVec_original = img(:,:,:,1);
redVec_original = img(:,:,:,2);
greenVec_original = greenVec_original(:);
redVec_original = redVec_original(:);
% Generate arrays of possible red and green thresholds
redThresholds = 5000:2000:30000;
greenThresholds = 5000:2000:30000;
for i = 1:length(redThresholds)
    for j = 1:length(greenThresholds)
        redVec = redVec_original;
        greenVec = greenVec_original;
        % Generate a mask of pixels that are either red or green.
        mask = redVec>=redThresholds(i) | greenVec>=greenThresholds(j);
        % Only keep "bright" pixels
        redVec = redVec(mask);
        greenVec = greenVec(mask);
        % Calculate the Manders overlap coefficient given red and green
        % thresholds
        brightRed = redVec>=redThresholds(i);
        brightGreen = greenVec>=greenThresholds(j);
        % Store in array
        M1(i,j) = sum(brightRed.*brightGreen)/sum(brightRed);
    end
end
% Plot results as a heatmap
heatmap(greenThresholds,redThresholds,M1);

        
