function [c,f,s ] = ReactionDiffusionPDE(x,t,u,dudx,P)
% Extract parameters
phi = P{1};
Beta = P{2};
K = P{3};
n = P{4};
c = 1;  % coefficient of time derivative
f = 1/(phi^2)*dudx; % coefficient of flux term
s = 1 + Beta * (x.^n)/(K.^n + x.^n);  % Source/Reaction Term; here constant plus a Hill Function
end
