function [out metadata] = openCZI_tiles(filename)
data = bfopen(filename);
[rows cols] = size(data);
if rows==9
    img1 = processTile(data{1,1});
    img2 = processTile(data{2,1});
    img3 = processTile(data{3,1});
    img4 = processTile(data{4,1});
    img5 = processTile(data{5,1});
    img6 = processTile(data{6,1});
    img7 = processTile(data{7,1});
    img8 = processTile(data{8,1});
    img9 = processTile(data{9,1});
    out = [img1 img2 img3; img4 img5 img6; img7 img8 img9];
    metadata = data{1,4};
elseif rows==1
    [out metadata] = openCZIFile(filename);
else
    error('Unexpected Size')
end
end
    
    
    
    
    
    
function out = processTile(data)
% Now parse strings of labels: Format is ...Z=x/N;C=y/N...
string = data{1,2};
% Find location in string of Z
x = strfind(string,'Z=');
% Find location in string of C
y = strfind(string,'C=');
% Trigger this condition if there are multiple C and Z stacks
if ~isempty(x)&& ~isempty(y)
    % Parse strings between slash and semicolon to get the denominators
    substring = string(x:end);
    semiInd = strfind(substring,';');
    slashInd = strfind(substring,'/');
    numZs = str2num(substring(slashInd(1)+1:semiInd-1));
    numCs = str2num(substring(slashInd(2)+1:end));
    % Get the first layer to determine the x and y dimesions
    firstLayer = data{1};
    [rows cols] = size(firstLayer);
    % Initialize the final data struction, a 4D uint16 structure
    out = uint16(zeros(rows,cols,numZs,numCs));
    k= 1
    % Loop through stacks, putting them in the final data structure
    for i = 1:numZs
        for j = 1:numCs
            %data{k,2}
            out(:,:,i,j) = data{k,1};
            k=k+1;
        end
    end
% Trigger this if there is only 1 z stack, but multiple colors
elseif ~isempty(y)
    % Find the number of channels
    slashInd = strfind(string,'/');
    numCs = str2num(string(slashInd(end)+1:end));
    % Add the stacks to the final data structure
    for i = 1:numCs
        out(:,:,i) = data{i,1};
    end
        out(:,:,3) = 0;
% Trigger this if there are multiple z stacks and only one channel
else
    % Get the number of z stacks
    slashInd = strfind(string,'/');
    numZs = str2num(string(slashInd(end)+1:end));
    % Add data to the final data structure
    for i = 1:numZs
        out(:,:,i,1) = data{i,1};
        out(:,:,i,2) = 0;
        out(:,:,i,3) = 0;
    end
end

end
